/* File: swiftmodule.c
 * This file is auto-generated with f2py (version:2.0.2).
 * f2py is a Fortran to Python Interface Generator (FPIG), Second Edition,
 * written by Pearu Peterson <pearu@cens.ioc.ee>.
 * Generation date: Wed Feb 26 08:23:11 2025
 * Do not edit this file directly unless you know what you are doing!!!
 */

#ifdef __cplusplus
extern "C" {
#endif

#ifndef PY_SSIZE_T_CLEAN
#define PY_SSIZE_T_CLEAN
#endif /* PY_SSIZE_T_CLEAN */

/* Unconditionally included */
#include <Python.h>
#include <numpy/npy_os.h>

/*********************** See f2py2e/cfuncs.py: includes ***********************/
#include "fortranobject.h"
#include <string.h>

/**************** See f2py2e/rules.py: mod_rules['modulebody'] ****************/
static PyObject *swift_error;
static PyObject *swift_module;

/*********************** See f2py2e/cfuncs.py: typedefs ***********************/
typedef char * string;

/****************** See f2py2e/cfuncs.py: typedefs_generated ******************/
/*need_typedefs_generated*/

/********************** See f2py2e/cfuncs.py: cppmacros **********************/
#define FAILNULL(p) do {                                            \
    if ((p) == NULL) {                                              \
        PyErr_SetString(PyExc_MemoryError, "NULL pointer found");   \
        goto capi_fail;                                             \
    }                                                               \
} while (0)


#define STRINGMALLOC(str,len)\
    if ((str = (string)malloc(len+1)) == NULL) {\
        PyErr_SetString(PyExc_MemoryError, "out of memory");\
        goto capi_fail;\
    } else {\
        (str)[len] = '\0';\
    }


#if defined(PREPEND_FORTRAN)
#if defined(NO_APPEND_FORTRAN)
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) _##F
#else
#define F_FUNC(f,F) _##f
#endif
#else
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) _##F##_
#else
#define F_FUNC(f,F) _##f##_
#endif
#endif
#else
#if defined(NO_APPEND_FORTRAN)
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) F
#else
#define F_FUNC(f,F) f
#endif
#else
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) F##_
#else
#define F_FUNC(f,F) f##_
#endif
#endif
#endif
#if defined(UNDERSCORE_G77)
#define F_FUNC_US(f,F) F_FUNC(f##_,F##_)
#else
#define F_FUNC_US(f,F) F_FUNC(f,F)
#endif


/* See fortranobject.h for definitions. The macros here are provided for BC. */
#define rank f2py_rank
#define shape f2py_shape
#define fshape f2py_shape
#define len f2py_len
#define flen f2py_flen
#define slen f2py_slen
#define size f2py_size


#ifdef DEBUGCFUNCS
#define CFUNCSMESS(mess) fprintf(stderr,"debug-capi:"mess);
#define CFUNCSMESSPY(mess,obj) CFUNCSMESS(mess) \
    PyObject_Print((PyObject *)obj,stderr,Py_PRINT_RAW);\
    fprintf(stderr,"\n");
#else
#define CFUNCSMESS(mess)
#define CFUNCSMESSPY(mess,obj)
#endif


#ifndef max
#define max(a,b) ((a > b) ? (a) : (b))
#endif
#ifndef min
#define min(a,b) ((a < b) ? (a) : (b))
#endif
#ifndef MAX
#define MAX(a,b) ((a > b) ? (a) : (b))
#endif
#ifndef MIN
#define MIN(a,b) ((a < b) ? (a) : (b))
#endif


#define STRINGFREE(str) do {if (!(str == NULL)) free(str);} while (0)


/*
STRINGPADN replaces null values with padding values from the right.

`to` must have size of at least N bytes.

If the `to[N-1]` has null value, then replace it and all the
preceding, nulls with the given padding.

STRINGPADN(to, N, PADDING, NULLVALUE) is an inverse operation.
*/
#define STRINGPADN(to, N, NULLVALUE, PADDING)                   \
    do {                                                        \
        int _m = (N);                                           \
        char *_to = (to);                                       \
        for (_m -= 1; _m >= 0 && _to[_m] == NULLVALUE; _m--) {  \
             _to[_m] = PADDING;                                 \
        }                                                       \
    } while (0)


/*
STRINGCOPYN copies N bytes.

`to` and `from` buffers must have sizes of at least N bytes.
*/
#define STRINGCOPYN(to,from,N)                                  \
    do {                                                        \
        int _m = (N);                                           \
        char *_to = (to);                                       \
        char *_from = (from);                                   \
        FAILNULL(_to); FAILNULL(_from);                         \
        (void)strncpy(_to, _from, _m);             \
    } while (0)


/************************ See f2py2e/cfuncs.py: cfuncs ************************/

static int
int_from_pyobj(int* v, PyObject *obj, const char *errmess)
{
    PyObject* tmp = NULL;

    if (PyLong_Check(obj)) {
        *v = Npy__PyLong_AsInt(obj);
        return !(*v == -1 && PyErr_Occurred());
    }

    tmp = PyNumber_Long(obj);
    if (tmp) {
        *v = Npy__PyLong_AsInt(tmp);
        Py_DECREF(tmp);
        return !(*v == -1 && PyErr_Occurred());
    }

    if (PyComplex_Check(obj)) {
        PyErr_Clear();
        tmp = PyObject_GetAttrString(obj,"real");
    }
    else if (PyBytes_Check(obj) || PyUnicode_Check(obj)) {
        /*pass*/;
    }
    else if (PySequence_Check(obj)) {
        PyErr_Clear();
        tmp = PySequence_GetItem(obj, 0);
    }

    if (tmp) {
        if (int_from_pyobj(v, tmp, errmess)) {
            Py_DECREF(tmp);
            return 1;
        }
        Py_DECREF(tmp);
    }

    {
        PyObject* err = PyErr_Occurred();
        if (err == NULL) {
            err = swift_error;
        }
        PyErr_SetString(err, errmess);
    }
    return 0;
}


static int
double_from_pyobj(double* v, PyObject *obj, const char *errmess)
{
    PyObject* tmp = NULL;
    if (PyFloat_Check(obj)) {
        *v = PyFloat_AsDouble(obj);
        return !(*v == -1.0 && PyErr_Occurred());
    }

    tmp = PyNumber_Float(obj);
    if (tmp) {
        *v = PyFloat_AsDouble(tmp);
        Py_DECREF(tmp);
        return !(*v == -1.0 && PyErr_Occurred());
    }

    if (PyComplex_Check(obj)) {
        PyErr_Clear();
        tmp = PyObject_GetAttrString(obj,"real");
    }
    else if (PyBytes_Check(obj) || PyUnicode_Check(obj)) {
        /*pass*/;
    }
    else if (PySequence_Check(obj)) {
        PyErr_Clear();
        tmp = PySequence_GetItem(obj, 0);
    }

    if (tmp) {
        if (double_from_pyobj(v,tmp,errmess)) {Py_DECREF(tmp); return 1;}
        Py_DECREF(tmp);
    }
    {
        PyObject* err = PyErr_Occurred();
        if (err==NULL) err = swift_error;
        PyErr_SetString(err,errmess);
    }
    return 0;
}


/*
  Create a new string buffer `str` of at most length `len` from a
  Python string-like object `obj`.

  The string buffer has given size (len) or the size of inistr when len==-1.

  The string buffer is padded with blanks: in Fortran, trailing blanks
  are insignificant contrary to C nulls.
 */
static int
string_from_pyobj(string *str, int *len, const string inistr, PyObject *obj,
                  const char *errmess)
{
    PyObject *tmp = NULL;
    string buf = NULL;
    npy_intp n = -1;
#ifdef DEBUGCFUNCS
fprintf(stderr,"string_from_pyobj(str='%s',len=%d,inistr='%s',obj=%p)\n",
               (char*)str, *len, (char *)inistr, obj);
#endif
    if (obj == Py_None) {
        n = strlen(inistr);
        buf = inistr;
    }
    else if (PyArray_Check(obj)) {
        PyArrayObject *arr = (PyArrayObject *)obj;
        if (!ISCONTIGUOUS(arr)) {
            PyErr_SetString(PyExc_ValueError,
                            "array object is non-contiguous.");
            goto capi_fail;
        }
        n = PyArray_NBYTES(arr);
        buf = PyArray_DATA(arr);
        n = strnlen(buf, n);
    }
    else {
        if (PyBytes_Check(obj)) {
            tmp = obj;
            Py_INCREF(tmp);
        }
        else if (PyUnicode_Check(obj)) {
            tmp = PyUnicode_AsASCIIString(obj);
        }
        else {
            PyObject *tmp2;
            tmp2 = PyObject_Str(obj);
            if (tmp2) {
                tmp = PyUnicode_AsASCIIString(tmp2);
                Py_DECREF(tmp2);
            }
            else {
                tmp = NULL;
            }
        }
        if (tmp == NULL) goto capi_fail;
        n = PyBytes_GET_SIZE(tmp);
        buf = PyBytes_AS_STRING(tmp);
    }
    if (*len == -1) {
        /* TODO: change the type of `len` so that we can remove this */
        if (n > NPY_MAX_INT) {
            PyErr_SetString(PyExc_OverflowError,
                            "object too large for a 32-bit int");
            goto capi_fail;
        }
        *len = n;
    }
    else if (*len < n) {
        /* discard the last (len-n) bytes of input buf */
        n = *len;
    }
    if (n < 0 || *len < 0 || buf == NULL) {
        goto capi_fail;
    }
    STRINGMALLOC(*str, *len);  // *str is allocated with size (*len + 1)
    if (n < *len) {
        /*
          Pad fixed-width string with nulls. The caller will replace
          nulls with blanks when the corresponding argument is not
          intent(c).
        */
        memset(*str + n, '\0', *len - n);
    }
    STRINGCOPYN(*str, buf, n);
    Py_XDECREF(tmp);
    return 1;
capi_fail:
    Py_XDECREF(tmp);
    {
        PyObject* err = PyErr_Occurred();
        if (err == NULL) {
            err = swift_error;
        }
        PyErr_SetString(err, errmess);
    }
    return 0;
}


/********************* See f2py2e/cfuncs.py: userincludes *********************/
/*need_userincludes*/

/********************* See f2py2e/capi_rules.py: usercode *********************/


/* See f2py2e/rules.py */
extern void F_FUNC_US(geninit_j3_in_days,GENINIT_J3_IN_DAYS)(int*,double*,int*,double*,double*,double*,double*);
extern void F_FUNC_US(swift_symba5_j,SWIFT_SYMBA5_J)(double*,double*,double*,double*,double*,char*,double*,double*,double*,double*,short*,string,string,int*,double*,double*,int*,double*,size_t,size_t);
extern void F_FUNC_US(swift_mvs_j,SWIFT_MVS_J)(double*,double*,double*,double*,double*,char*,double*,double*,double*,double*,short*,string,string,int*,double*,int*,double*,size_t,size_t);
extern void F_FUNC_US(swift_mvs_j_gr,SWIFT_MVS_J_GR)(double*,double*,double*,double*,double*,char*,double*,double*,double*,double*,short*,string,string,int*,double*,int*,int*,double*,size_t,size_t);
extern void F_FUNC_US(follow_symba2,FOLLOW_SYMBA2)(double*,double*,double*,double*,double*,char*,double*,double*,double*,double*,short*,string,string,int*,double*,int*,int*,double*,size_t,size_t);
/*eof externroutines*/

/******************** See f2py2e/capi_rules.py: usercode1 ********************/


/******************* See f2py2e/cb_rules.py: buildcallback *******************/
/*need_callbacks*/

/*********************** See f2py2e/rules.py: buildapi ***********************/

/***************************** geninit_j3_in_days *****************************/
static char doc_f2py_rout_swift_geninit_j3_in_days[] = "\
planets_results,coordinates = geninit_j3_in_days(iuflg,mstar0,nbod,frho3,planets_params)\n\nWrapper for ``geninit_j3_in_days``.\
\n\nParameters\n----------\n"
"iuflg : input int\n"
"mstar0 : input float\n"
"nbod : input int\n"
"frho3 : input float\n"
"planets_params : input rank-2 array('d') with bounds (nbod,7)\n"
"\nReturns\n-------\n"
"planets_results : rank-2 array('d') with bounds (nbod,9)\n"
"coordinates : rank-2 array('d') with bounds (3 + 3 * nbod,3)";
/* extern void F_FUNC_US(geninit_j3_in_days,GENINIT_J3_IN_DAYS)(int*,double*,int*,double*,double*,double*,double*); */
static PyObject *f2py_rout_swift_geninit_j3_in_days(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,double*,int*,double*,double*,double*,double*)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    int iuflg = 0;
    PyObject *iuflg_capi = Py_None;
    double mstar0 = 0;
    PyObject *mstar0_capi = Py_None;
    int nbod = 0;
    PyObject *nbod_capi = Py_None;
    double frho3 = 0;
    PyObject *frho3_capi = Py_None;
    double *planets_params = NULL;
    npy_intp planets_params_Dims[2] = {-1, -1};
    const int planets_params_Rank = 2;
    PyArrayObject *capi_planets_params_as_array = NULL;
    int capi_planets_params_intent = 0;
    PyObject *planets_params_capi = Py_None;
    double *planets_results = NULL;
    npy_intp planets_results_Dims[2] = {-1, -1};
    const int planets_results_Rank = 2;
    PyArrayObject *capi_planets_results_as_array = NULL;
    int capi_planets_results_intent = 0;
    double *coordinates = NULL;
    npy_intp coordinates_Dims[2] = {-1, -1};
    const int coordinates_Rank = 2;
    PyArrayObject *capi_coordinates_as_array = NULL;
    int capi_coordinates_intent = 0;
    static char *capi_kwlist[] = {"iuflg","mstar0","nbod","frho3","planets_params",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOOO|:swift.geninit_j3_in_days",\
        capi_kwlist,&iuflg_capi,&mstar0_capi,&nbod_capi,&frho3_capi,&planets_params_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable nbod */
        f2py_success = int_from_pyobj(&nbod,nbod_capi,"swift.geninit_j3_in_days() 3rd argument (nbod) can't be converted to int");
    if (f2py_success) {
    /* Processing variable mstar0 */
        f2py_success = double_from_pyobj(&mstar0,mstar0_capi,"swift.geninit_j3_in_days() 2nd argument (mstar0) can't be converted to double");
    if (f2py_success) {
    /* Processing variable frho3 */
        f2py_success = double_from_pyobj(&frho3,frho3_capi,"swift.geninit_j3_in_days() 4th argument (frho3) can't be converted to double");
    if (f2py_success) {
    /* Processing variable iuflg */
        f2py_success = int_from_pyobj(&iuflg,iuflg_capi,"swift.geninit_j3_in_days() 1st argument (iuflg) can't be converted to int");
    if (f2py_success) {
    /* Processing variable planets_params */
    planets_params_Dims[0]=nbod,planets_params_Dims[1]=7;
    capi_planets_params_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "swift.swift.geninit_j3_in_days: failed to create array from the 5th argument `planets_params`";
    capi_planets_params_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,planets_params_Dims,planets_params_Rank,  capi_planets_params_intent,planets_params_capi,capi_errmess);
    if (capi_planets_params_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = swift_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        planets_params = (double *)(PyArray_DATA(capi_planets_params_as_array));

    /* Processing variable planets_results */
    planets_results_Dims[0]=nbod,planets_results_Dims[1]=9;
    capi_planets_results_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "swift.swift.geninit_j3_in_days: failed to create array from the hidden `planets_results`";
    capi_planets_results_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,planets_results_Dims,planets_results_Rank,  capi_planets_results_intent,Py_None,capi_errmess);
    if (capi_planets_results_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = swift_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        planets_results = (double *)(PyArray_DATA(capi_planets_results_as_array));

    /* Processing variable coordinates */
    coordinates_Dims[0]=3 + 3 * nbod,coordinates_Dims[1]=3;
    capi_coordinates_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "swift.swift.geninit_j3_in_days: failed to create array from the hidden `coordinates`";
    capi_coordinates_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,coordinates_Dims,coordinates_Rank,  capi_coordinates_intent,Py_None,capi_errmess);
    if (capi_coordinates_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = swift_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        coordinates = (double *)(PyArray_DATA(capi_coordinates_as_array));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
                (*f2py_func)(&iuflg,&mstar0,&nbod,&frho3,planets_params,planets_results,coordinates);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("NN",capi_planets_results_as_array,capi_coordinates_as_array);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    }  /* if (capi_coordinates_as_array == NULL) ... else of coordinates */
    /* End of cleaning variable coordinates */
    }  /* if (capi_planets_results_as_array == NULL) ... else of planets_results */
    /* End of cleaning variable planets_results */
    if((PyObject *)capi_planets_params_as_array!=planets_params_capi) {
        Py_XDECREF(capi_planets_params_as_array); }
    }  /* if (capi_planets_params_as_array == NULL) ... else of planets_params */
    /* End of cleaning variable planets_params */
    } /*if (f2py_success) of iuflg*/
    /* End of cleaning variable iuflg */
    } /*if (f2py_success) of frho3*/
    /* End of cleaning variable frho3 */
    } /*if (f2py_success) of mstar0*/
    /* End of cleaning variable mstar0 */
    } /*if (f2py_success) of nbod*/
    /* End of cleaning variable nbod */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/************************* end of geninit_j3_in_days *************************/

/******************************* swift_symba5_j *******************************/
static char doc_f2py_rout_swift_swift_symba5_j[] = "\
energy_out = swift_symba5_j(t0,tstop,dt,dtout,dtdump,lflg,rmin,rmax,rmaxu,qmin,lclose,outfile,fopenstat,nbod,coordinates,mtiny,energy_out_size)\n\nWrapper for ``swift_symba5_j``.\
\n\nParameters\n----------\n"
"t0 : input float\n"
"tstop : input float\n"
"dt : input float\n"
"dtout : input float\n"
"dtdump : input float\n"
"lflg : input rank-1 array('b') with bounds (6)\n"
"rmin : input float\n"
"rmax : input float\n"
"rmaxu : input float\n"
"qmin : input float\n"
"lclose : input int\n"
"outfile : input string(len=80)\n"
"fopenstat : input string(len=80)\n"
"nbod : input int\n"
"coordinates : input rank-2 array('d') with bounds (3 + 3 * nbod,3)\n"
"mtiny : input float\n"
"energy_out_size : input int\n"
"\nReturns\n-------\n"
"energy_out : rank-2 array('d') with bounds (energy_out_size,5)";
/* extern void F_FUNC_US(swift_symba5_j,SWIFT_SYMBA5_J)(double*,double*,double*,double*,double*,char*,double*,double*,double*,double*,short*,string,string,int*,double*,double*,int*,double*,size_t,size_t); */
static PyObject *f2py_rout_swift_swift_symba5_j(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,double*,double*,double*,double*,char*,double*,double*,double*,double*,short*,string,string,int*,double*,double*,int*,double*,size_t,size_t)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    double t0 = 0;
    PyObject *t0_capi = Py_None;
    double tstop = 0;
    PyObject *tstop_capi = Py_None;
    double dt = 0;
    PyObject *dt_capi = Py_None;
    double dtout = 0;
    PyObject *dtout_capi = Py_None;
    double dtdump = 0;
    PyObject *dtdump_capi = Py_None;
    char *lflg = NULL;
    npy_intp lflg_Dims[1] = {-1};
    const int lflg_Rank = 1;
    PyArrayObject *capi_lflg_as_array = NULL;
    int capi_lflg_intent = 0;
    PyObject *lflg_capi = Py_None;
    double rmin = 0;
    PyObject *rmin_capi = Py_None;
    double rmax = 0;
    PyObject *rmax_capi = Py_None;
    double rmaxu = 0;
    PyObject *rmaxu_capi = Py_None;
    double qmin = 0;
    PyObject *qmin_capi = Py_None;
    short lclose = 0;
    PyObject *lclose_capi = Py_None;
    string outfile = NULL;
    int slen(outfile);
    PyObject *outfile_capi = Py_None;
    string fopenstat = NULL;
    int slen(fopenstat);
    PyObject *fopenstat_capi = Py_None;
    int nbod = 0;
    PyObject *nbod_capi = Py_None;
    double *coordinates = NULL;
    npy_intp coordinates_Dims[2] = {-1, -1};
    const int coordinates_Rank = 2;
    PyArrayObject *capi_coordinates_as_array = NULL;
    int capi_coordinates_intent = 0;
    PyObject *coordinates_capi = Py_None;
    double mtiny = 0;
    PyObject *mtiny_capi = Py_None;
    int energy_out_size = 0;
    PyObject *energy_out_size_capi = Py_None;
    double *energy_out = NULL;
    npy_intp energy_out_Dims[2] = {-1, -1};
    const int energy_out_Rank = 2;
    PyArrayObject *capi_energy_out_as_array = NULL;
    int capi_energy_out_intent = 0;
    static char *capi_kwlist[] = {"t0","tstop","dt","dtout","dtdump","lflg","rmin","rmax","rmaxu","qmin","lclose","outfile","fopenstat","nbod","coordinates","mtiny","energy_out_size",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOOOOOOOOOOOOOOO|:swift.swift_symba5_j",\
        capi_kwlist,&t0_capi,&tstop_capi,&dt_capi,&dtout_capi,&dtdump_capi,&lflg_capi,&rmin_capi,&rmax_capi,&rmaxu_capi,&qmin_capi,&lclose_capi,&outfile_capi,&fopenstat_capi,&nbod_capi,&coordinates_capi,&mtiny_capi,&energy_out_size_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable nbod */
        f2py_success = int_from_pyobj(&nbod,nbod_capi,"swift.swift_symba5_j() 14th argument (nbod) can't be converted to int");
    if (f2py_success) {
    /* Processing variable t0 */
        f2py_success = double_from_pyobj(&t0,t0_capi,"swift.swift_symba5_j() 1st argument (t0) can't be converted to double");
    if (f2py_success) {
    /* Processing variable tstop */
        f2py_success = double_from_pyobj(&tstop,tstop_capi,"swift.swift_symba5_j() 2nd argument (tstop) can't be converted to double");
    if (f2py_success) {
    /* Processing variable dt */
        f2py_success = double_from_pyobj(&dt,dt_capi,"swift.swift_symba5_j() 3rd argument (dt) can't be converted to double");
    if (f2py_success) {
    /* Processing variable dtout */
        f2py_success = double_from_pyobj(&dtout,dtout_capi,"swift.swift_symba5_j() 4th argument (dtout) can't be converted to double");
    if (f2py_success) {
    /* Processing variable dtdump */
        f2py_success = double_from_pyobj(&dtdump,dtdump_capi,"swift.swift_symba5_j() 5th argument (dtdump) can't be converted to double");
    if (f2py_success) {
    /* Processing variable rmin */
        f2py_success = double_from_pyobj(&rmin,rmin_capi,"swift.swift_symba5_j() 7th argument (rmin) can't be converted to double");
    if (f2py_success) {
    /* Processing variable rmax */
        f2py_success = double_from_pyobj(&rmax,rmax_capi,"swift.swift_symba5_j() 8th argument (rmax) can't be converted to double");
    if (f2py_success) {
    /* Processing variable rmaxu */
        f2py_success = double_from_pyobj(&rmaxu,rmaxu_capi,"swift.swift_symba5_j() 9th argument (rmaxu) can't be converted to double");
    if (f2py_success) {
    /* Processing variable qmin */
        f2py_success = double_from_pyobj(&qmin,qmin_capi,"swift.swift_symba5_j() 10th argument (qmin) can't be converted to double");
    if (f2py_success) {
    /* Processing variable mtiny */
        f2py_success = double_from_pyobj(&mtiny,mtiny_capi,"swift.swift_symba5_j() 16th argument (mtiny) can't be converted to double");
    if (f2py_success) {
    /* Processing variable lclose */
        lclose = (short)PyObject_IsTrue(lclose_capi);
        f2py_success = 1;
    if (f2py_success) {
    /* Processing variable outfile */
    slen(outfile) = 80;
    f2py_success = string_from_pyobj(&outfile,&slen(outfile),"",outfile_capi,"string_from_pyobj failed in converting 12nd argument`outfile' of swift.swift_symba5_j to C string");
    if (f2py_success) {
        STRINGPADN(outfile, slen(outfile), '\0', ' ');
    /* Processing variable fopenstat */
    slen(fopenstat) = 80;
    f2py_success = string_from_pyobj(&fopenstat,&slen(fopenstat),"",fopenstat_capi,"string_from_pyobj failed in converting 13rd argument`fopenstat' of swift.swift_symba5_j to C string");
    if (f2py_success) {
        STRINGPADN(fopenstat, slen(fopenstat), '\0', ' ');
    /* Processing variable lflg */
    lflg_Dims[0]=6;
    capi_lflg_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "swift.swift.swift_symba5_j: failed to create array from the 6th argument `lflg`";
    capi_lflg_as_array = ndarray_from_pyobj(  NPY_BYTE,1,lflg_Dims,lflg_Rank,  capi_lflg_intent,lflg_capi,capi_errmess);
    if (capi_lflg_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = swift_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        lflg = (char *)(PyArray_DATA(capi_lflg_as_array));

    /* Processing variable energy_out_size */
        f2py_success = int_from_pyobj(&energy_out_size,energy_out_size_capi,"swift.swift_symba5_j() 17th argument (energy_out_size) can't be converted to int");
    if (f2py_success) {
    /* Processing variable coordinates */
    coordinates_Dims[0]=3 + 3 * nbod,coordinates_Dims[1]=3;
    capi_coordinates_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "swift.swift.swift_symba5_j: failed to create array from the 15th argument `coordinates`";
    capi_coordinates_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,coordinates_Dims,coordinates_Rank,  capi_coordinates_intent,coordinates_capi,capi_errmess);
    if (capi_coordinates_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = swift_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        coordinates = (double *)(PyArray_DATA(capi_coordinates_as_array));

    /* Processing variable energy_out */
    energy_out_Dims[0]=energy_out_size,energy_out_Dims[1]=5;
    capi_energy_out_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "swift.swift.swift_symba5_j: failed to create array from the hidden `energy_out`";
    capi_energy_out_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,energy_out_Dims,energy_out_Rank,  capi_energy_out_intent,Py_None,capi_errmess);
    if (capi_energy_out_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = swift_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        energy_out = (double *)(PyArray_DATA(capi_energy_out_as_array));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
                (*f2py_func)(&t0,&tstop,&dt,&dtout,&dtdump,lflg,&rmin,&rmax,&rmaxu,&qmin,&lclose,outfile,fopenstat,&nbod,coordinates,&mtiny,&energy_out_size,energy_out,slen(outfile),slen(fopenstat));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("N",capi_energy_out_as_array);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    }  /* if (capi_energy_out_as_array == NULL) ... else of energy_out */
    /* End of cleaning variable energy_out */
    if((PyObject *)capi_coordinates_as_array!=coordinates_capi) {
        Py_XDECREF(capi_coordinates_as_array); }
    }  /* if (capi_coordinates_as_array == NULL) ... else of coordinates */
    /* End of cleaning variable coordinates */
    } /*if (f2py_success) of energy_out_size*/
    /* End of cleaning variable energy_out_size */
    if((PyObject *)capi_lflg_as_array!=lflg_capi) {
        Py_XDECREF(capi_lflg_as_array); }
    }  /* if (capi_lflg_as_array == NULL) ... else of lflg */
    /* End of cleaning variable lflg */
        STRINGFREE(fopenstat);
    }  /*if (f2py_success) of fopenstat*/
    /* End of cleaning variable fopenstat */
        STRINGFREE(outfile);
    }  /*if (f2py_success) of outfile*/
    /* End of cleaning variable outfile */
    } /*if (f2py_success) of lclose*/
    /* End of cleaning variable lclose */
    } /*if (f2py_success) of mtiny*/
    /* End of cleaning variable mtiny */
    } /*if (f2py_success) of qmin*/
    /* End of cleaning variable qmin */
    } /*if (f2py_success) of rmaxu*/
    /* End of cleaning variable rmaxu */
    } /*if (f2py_success) of rmax*/
    /* End of cleaning variable rmax */
    } /*if (f2py_success) of rmin*/
    /* End of cleaning variable rmin */
    } /*if (f2py_success) of dtdump*/
    /* End of cleaning variable dtdump */
    } /*if (f2py_success) of dtout*/
    /* End of cleaning variable dtout */
    } /*if (f2py_success) of dt*/
    /* End of cleaning variable dt */
    } /*if (f2py_success) of tstop*/
    /* End of cleaning variable tstop */
    } /*if (f2py_success) of t0*/
    /* End of cleaning variable t0 */
    } /*if (f2py_success) of nbod*/
    /* End of cleaning variable nbod */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/*************************** end of swift_symba5_j ***************************/

/******************************** swift_mvs_j ********************************/
static char doc_f2py_rout_swift_swift_mvs_j[] = "\
energy_out = swift_mvs_j(t0,tstop,dt,dtout,dtdump,lflg,rmin,rmax,rmaxu,qmin,lclose,outfile,fopenstat,nbod,coordinates,energy_out_size)\n\nWrapper for ``swift_mvs_j``.\
\n\nParameters\n----------\n"
"t0 : input float\n"
"tstop : input float\n"
"dt : input float\n"
"dtout : input float\n"
"dtdump : input float\n"
"lflg : input rank-1 array('b') with bounds (6)\n"
"rmin : input float\n"
"rmax : input float\n"
"rmaxu : input float\n"
"qmin : input float\n"
"lclose : input int\n"
"outfile : input string(len=80)\n"
"fopenstat : input string(len=80)\n"
"nbod : input int\n"
"coordinates : input rank-2 array('d') with bounds (3 + 3 * nbod,3)\n"
"energy_out_size : input int\n"
"\nReturns\n-------\n"
"energy_out : rank-2 array('d') with bounds (energy_out_size,5)";
/* extern void F_FUNC_US(swift_mvs_j,SWIFT_MVS_J)(double*,double*,double*,double*,double*,char*,double*,double*,double*,double*,short*,string,string,int*,double*,int*,double*,size_t,size_t); */
static PyObject *f2py_rout_swift_swift_mvs_j(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,double*,double*,double*,double*,char*,double*,double*,double*,double*,short*,string,string,int*,double*,int*,double*,size_t,size_t)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    double t0 = 0;
    PyObject *t0_capi = Py_None;
    double tstop = 0;
    PyObject *tstop_capi = Py_None;
    double dt = 0;
    PyObject *dt_capi = Py_None;
    double dtout = 0;
    PyObject *dtout_capi = Py_None;
    double dtdump = 0;
    PyObject *dtdump_capi = Py_None;
    char *lflg = NULL;
    npy_intp lflg_Dims[1] = {-1};
    const int lflg_Rank = 1;
    PyArrayObject *capi_lflg_as_array = NULL;
    int capi_lflg_intent = 0;
    PyObject *lflg_capi = Py_None;
    double rmin = 0;
    PyObject *rmin_capi = Py_None;
    double rmax = 0;
    PyObject *rmax_capi = Py_None;
    double rmaxu = 0;
    PyObject *rmaxu_capi = Py_None;
    double qmin = 0;
    PyObject *qmin_capi = Py_None;
    short lclose = 0;
    PyObject *lclose_capi = Py_None;
    string outfile = NULL;
    int slen(outfile);
    PyObject *outfile_capi = Py_None;
    string fopenstat = NULL;
    int slen(fopenstat);
    PyObject *fopenstat_capi = Py_None;
    int nbod = 0;
    PyObject *nbod_capi = Py_None;
    double *coordinates = NULL;
    npy_intp coordinates_Dims[2] = {-1, -1};
    const int coordinates_Rank = 2;
    PyArrayObject *capi_coordinates_as_array = NULL;
    int capi_coordinates_intent = 0;
    PyObject *coordinates_capi = Py_None;
    int energy_out_size = 0;
    PyObject *energy_out_size_capi = Py_None;
    double *energy_out = NULL;
    npy_intp energy_out_Dims[2] = {-1, -1};
    const int energy_out_Rank = 2;
    PyArrayObject *capi_energy_out_as_array = NULL;
    int capi_energy_out_intent = 0;
    static char *capi_kwlist[] = {"t0","tstop","dt","dtout","dtdump","lflg","rmin","rmax","rmaxu","qmin","lclose","outfile","fopenstat","nbod","coordinates","energy_out_size",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOOOOOOOOOOOOOO|:swift.swift_mvs_j",\
        capi_kwlist,&t0_capi,&tstop_capi,&dt_capi,&dtout_capi,&dtdump_capi,&lflg_capi,&rmin_capi,&rmax_capi,&rmaxu_capi,&qmin_capi,&lclose_capi,&outfile_capi,&fopenstat_capi,&nbod_capi,&coordinates_capi,&energy_out_size_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable nbod */
        f2py_success = int_from_pyobj(&nbod,nbod_capi,"swift.swift_mvs_j() 14th argument (nbod) can't be converted to int");
    if (f2py_success) {
    /* Processing variable t0 */
        f2py_success = double_from_pyobj(&t0,t0_capi,"swift.swift_mvs_j() 1st argument (t0) can't be converted to double");
    if (f2py_success) {
    /* Processing variable tstop */
        f2py_success = double_from_pyobj(&tstop,tstop_capi,"swift.swift_mvs_j() 2nd argument (tstop) can't be converted to double");
    if (f2py_success) {
    /* Processing variable dt */
        f2py_success = double_from_pyobj(&dt,dt_capi,"swift.swift_mvs_j() 3rd argument (dt) can't be converted to double");
    if (f2py_success) {
    /* Processing variable dtout */
        f2py_success = double_from_pyobj(&dtout,dtout_capi,"swift.swift_mvs_j() 4th argument (dtout) can't be converted to double");
    if (f2py_success) {
    /* Processing variable dtdump */
        f2py_success = double_from_pyobj(&dtdump,dtdump_capi,"swift.swift_mvs_j() 5th argument (dtdump) can't be converted to double");
    if (f2py_success) {
    /* Processing variable rmin */
        f2py_success = double_from_pyobj(&rmin,rmin_capi,"swift.swift_mvs_j() 7th argument (rmin) can't be converted to double");
    if (f2py_success) {
    /* Processing variable rmax */
        f2py_success = double_from_pyobj(&rmax,rmax_capi,"swift.swift_mvs_j() 8th argument (rmax) can't be converted to double");
    if (f2py_success) {
    /* Processing variable rmaxu */
        f2py_success = double_from_pyobj(&rmaxu,rmaxu_capi,"swift.swift_mvs_j() 9th argument (rmaxu) can't be converted to double");
    if (f2py_success) {
    /* Processing variable qmin */
        f2py_success = double_from_pyobj(&qmin,qmin_capi,"swift.swift_mvs_j() 10th argument (qmin) can't be converted to double");
    if (f2py_success) {
    /* Processing variable lclose */
        lclose = (short)PyObject_IsTrue(lclose_capi);
        f2py_success = 1;
    if (f2py_success) {
    /* Processing variable outfile */
    slen(outfile) = 80;
    f2py_success = string_from_pyobj(&outfile,&slen(outfile),"",outfile_capi,"string_from_pyobj failed in converting 12nd argument`outfile' of swift.swift_mvs_j to C string");
    if (f2py_success) {
        STRINGPADN(outfile, slen(outfile), '\0', ' ');
    /* Processing variable fopenstat */
    slen(fopenstat) = 80;
    f2py_success = string_from_pyobj(&fopenstat,&slen(fopenstat),"",fopenstat_capi,"string_from_pyobj failed in converting 13rd argument`fopenstat' of swift.swift_mvs_j to C string");
    if (f2py_success) {
        STRINGPADN(fopenstat, slen(fopenstat), '\0', ' ');
    /* Processing variable lflg */
    lflg_Dims[0]=6;
    capi_lflg_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "swift.swift.swift_mvs_j: failed to create array from the 6th argument `lflg`";
    capi_lflg_as_array = ndarray_from_pyobj(  NPY_BYTE,1,lflg_Dims,lflg_Rank,  capi_lflg_intent,lflg_capi,capi_errmess);
    if (capi_lflg_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = swift_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        lflg = (char *)(PyArray_DATA(capi_lflg_as_array));

    /* Processing variable energy_out_size */
        f2py_success = int_from_pyobj(&energy_out_size,energy_out_size_capi,"swift.swift_mvs_j() 16th argument (energy_out_size) can't be converted to int");
    if (f2py_success) {
    /* Processing variable coordinates */
    coordinates_Dims[0]=3 + 3 * nbod,coordinates_Dims[1]=3;
    capi_coordinates_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "swift.swift.swift_mvs_j: failed to create array from the 15th argument `coordinates`";
    capi_coordinates_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,coordinates_Dims,coordinates_Rank,  capi_coordinates_intent,coordinates_capi,capi_errmess);
    if (capi_coordinates_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = swift_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        coordinates = (double *)(PyArray_DATA(capi_coordinates_as_array));

    /* Processing variable energy_out */
    energy_out_Dims[0]=energy_out_size,energy_out_Dims[1]=5;
    capi_energy_out_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "swift.swift.swift_mvs_j: failed to create array from the hidden `energy_out`";
    capi_energy_out_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,energy_out_Dims,energy_out_Rank,  capi_energy_out_intent,Py_None,capi_errmess);
    if (capi_energy_out_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = swift_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        energy_out = (double *)(PyArray_DATA(capi_energy_out_as_array));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
                (*f2py_func)(&t0,&tstop,&dt,&dtout,&dtdump,lflg,&rmin,&rmax,&rmaxu,&qmin,&lclose,outfile,fopenstat,&nbod,coordinates,&energy_out_size,energy_out,slen(outfile),slen(fopenstat));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("N",capi_energy_out_as_array);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    }  /* if (capi_energy_out_as_array == NULL) ... else of energy_out */
    /* End of cleaning variable energy_out */
    if((PyObject *)capi_coordinates_as_array!=coordinates_capi) {
        Py_XDECREF(capi_coordinates_as_array); }
    }  /* if (capi_coordinates_as_array == NULL) ... else of coordinates */
    /* End of cleaning variable coordinates */
    } /*if (f2py_success) of energy_out_size*/
    /* End of cleaning variable energy_out_size */
    if((PyObject *)capi_lflg_as_array!=lflg_capi) {
        Py_XDECREF(capi_lflg_as_array); }
    }  /* if (capi_lflg_as_array == NULL) ... else of lflg */
    /* End of cleaning variable lflg */
        STRINGFREE(fopenstat);
    }  /*if (f2py_success) of fopenstat*/
    /* End of cleaning variable fopenstat */
        STRINGFREE(outfile);
    }  /*if (f2py_success) of outfile*/
    /* End of cleaning variable outfile */
    } /*if (f2py_success) of lclose*/
    /* End of cleaning variable lclose */
    } /*if (f2py_success) of qmin*/
    /* End of cleaning variable qmin */
    } /*if (f2py_success) of rmaxu*/
    /* End of cleaning variable rmaxu */
    } /*if (f2py_success) of rmax*/
    /* End of cleaning variable rmax */
    } /*if (f2py_success) of rmin*/
    /* End of cleaning variable rmin */
    } /*if (f2py_success) of dtdump*/
    /* End of cleaning variable dtdump */
    } /*if (f2py_success) of dtout*/
    /* End of cleaning variable dtout */
    } /*if (f2py_success) of dt*/
    /* End of cleaning variable dt */
    } /*if (f2py_success) of tstop*/
    /* End of cleaning variable tstop */
    } /*if (f2py_success) of t0*/
    /* End of cleaning variable t0 */
    } /*if (f2py_success) of nbod*/
    /* End of cleaning variable nbod */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/***************************** end of swift_mvs_j *****************************/

/******************************* swift_mvs_j_gr *******************************/
static char doc_f2py_rout_swift_swift_mvs_j_gr[] = "\
energy_out = swift_mvs_j_gr(t0,tstop,dt,dtout,dtdump,lflg,rmin,rmax,rmaxu,qmin,lclose,outfile,fopenstat,nbod,coordinates,ll,energy_out_size)\n\nWrapper for ``swift_mvs_j_gr``.\
\n\nParameters\n----------\n"
"t0 : input float\n"
"tstop : input float\n"
"dt : input float\n"
"dtout : input float\n"
"dtdump : input float\n"
"lflg : input rank-1 array('b') with bounds (6)\n"
"rmin : input float\n"
"rmax : input float\n"
"rmaxu : input float\n"
"qmin : input float\n"
"lclose : input int\n"
"outfile : input string(len=80)\n"
"fopenstat : input string(len=80)\n"
"nbod : input int\n"
"coordinates : input rank-2 array('d') with bounds (3 + 3 * nbod,3)\n"
"ll : input int\n"
"energy_out_size : input int\n"
"\nReturns\n-------\n"
"energy_out : rank-2 array('d') with bounds (energy_out_size,5)";
/* extern void F_FUNC_US(swift_mvs_j_gr,SWIFT_MVS_J_GR)(double*,double*,double*,double*,double*,char*,double*,double*,double*,double*,short*,string,string,int*,double*,int*,int*,double*,size_t,size_t); */
static PyObject *f2py_rout_swift_swift_mvs_j_gr(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,double*,double*,double*,double*,char*,double*,double*,double*,double*,short*,string,string,int*,double*,int*,int*,double*,size_t,size_t)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    double t0 = 0;
    PyObject *t0_capi = Py_None;
    double tstop = 0;
    PyObject *tstop_capi = Py_None;
    double dt = 0;
    PyObject *dt_capi = Py_None;
    double dtout = 0;
    PyObject *dtout_capi = Py_None;
    double dtdump = 0;
    PyObject *dtdump_capi = Py_None;
    char *lflg = NULL;
    npy_intp lflg_Dims[1] = {-1};
    const int lflg_Rank = 1;
    PyArrayObject *capi_lflg_as_array = NULL;
    int capi_lflg_intent = 0;
    PyObject *lflg_capi = Py_None;
    double rmin = 0;
    PyObject *rmin_capi = Py_None;
    double rmax = 0;
    PyObject *rmax_capi = Py_None;
    double rmaxu = 0;
    PyObject *rmaxu_capi = Py_None;
    double qmin = 0;
    PyObject *qmin_capi = Py_None;
    short lclose = 0;
    PyObject *lclose_capi = Py_None;
    string outfile = NULL;
    int slen(outfile);
    PyObject *outfile_capi = Py_None;
    string fopenstat = NULL;
    int slen(fopenstat);
    PyObject *fopenstat_capi = Py_None;
    int nbod = 0;
    PyObject *nbod_capi = Py_None;
    double *coordinates = NULL;
    npy_intp coordinates_Dims[2] = {-1, -1};
    const int coordinates_Rank = 2;
    PyArrayObject *capi_coordinates_as_array = NULL;
    int capi_coordinates_intent = 0;
    PyObject *coordinates_capi = Py_None;
    int ll = 0;
    PyObject *ll_capi = Py_None;
    int energy_out_size = 0;
    PyObject *energy_out_size_capi = Py_None;
    double *energy_out = NULL;
    npy_intp energy_out_Dims[2] = {-1, -1};
    const int energy_out_Rank = 2;
    PyArrayObject *capi_energy_out_as_array = NULL;
    int capi_energy_out_intent = 0;
    static char *capi_kwlist[] = {"t0","tstop","dt","dtout","dtdump","lflg","rmin","rmax","rmaxu","qmin","lclose","outfile","fopenstat","nbod","coordinates","ll","energy_out_size",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOOOOOOOOOOOOOOO|:swift.swift_mvs_j_gr",\
        capi_kwlist,&t0_capi,&tstop_capi,&dt_capi,&dtout_capi,&dtdump_capi,&lflg_capi,&rmin_capi,&rmax_capi,&rmaxu_capi,&qmin_capi,&lclose_capi,&outfile_capi,&fopenstat_capi,&nbod_capi,&coordinates_capi,&ll_capi,&energy_out_size_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable ll */
        f2py_success = int_from_pyobj(&ll,ll_capi,"swift.swift_mvs_j_gr() 16th argument (ll) can't be converted to int");
    if (f2py_success) {
    /* Processing variable nbod */
        f2py_success = int_from_pyobj(&nbod,nbod_capi,"swift.swift_mvs_j_gr() 14th argument (nbod) can't be converted to int");
    if (f2py_success) {
    /* Processing variable t0 */
        f2py_success = double_from_pyobj(&t0,t0_capi,"swift.swift_mvs_j_gr() 1st argument (t0) can't be converted to double");
    if (f2py_success) {
    /* Processing variable tstop */
        f2py_success = double_from_pyobj(&tstop,tstop_capi,"swift.swift_mvs_j_gr() 2nd argument (tstop) can't be converted to double");
    if (f2py_success) {
    /* Processing variable dt */
        f2py_success = double_from_pyobj(&dt,dt_capi,"swift.swift_mvs_j_gr() 3rd argument (dt) can't be converted to double");
    if (f2py_success) {
    /* Processing variable dtout */
        f2py_success = double_from_pyobj(&dtout,dtout_capi,"swift.swift_mvs_j_gr() 4th argument (dtout) can't be converted to double");
    if (f2py_success) {
    /* Processing variable dtdump */
        f2py_success = double_from_pyobj(&dtdump,dtdump_capi,"swift.swift_mvs_j_gr() 5th argument (dtdump) can't be converted to double");
    if (f2py_success) {
    /* Processing variable rmin */
        f2py_success = double_from_pyobj(&rmin,rmin_capi,"swift.swift_mvs_j_gr() 7th argument (rmin) can't be converted to double");
    if (f2py_success) {
    /* Processing variable rmax */
        f2py_success = double_from_pyobj(&rmax,rmax_capi,"swift.swift_mvs_j_gr() 8th argument (rmax) can't be converted to double");
    if (f2py_success) {
    /* Processing variable rmaxu */
        f2py_success = double_from_pyobj(&rmaxu,rmaxu_capi,"swift.swift_mvs_j_gr() 9th argument (rmaxu) can't be converted to double");
    if (f2py_success) {
    /* Processing variable qmin */
        f2py_success = double_from_pyobj(&qmin,qmin_capi,"swift.swift_mvs_j_gr() 10th argument (qmin) can't be converted to double");
    if (f2py_success) {
    /* Processing variable lclose */
        lclose = (short)PyObject_IsTrue(lclose_capi);
        f2py_success = 1;
    if (f2py_success) {
    /* Processing variable outfile */
    slen(outfile) = 80;
    f2py_success = string_from_pyobj(&outfile,&slen(outfile),"",outfile_capi,"string_from_pyobj failed in converting 12nd argument`outfile' of swift.swift_mvs_j_gr to C string");
    if (f2py_success) {
        STRINGPADN(outfile, slen(outfile), '\0', ' ');
    /* Processing variable fopenstat */
    slen(fopenstat) = 80;
    f2py_success = string_from_pyobj(&fopenstat,&slen(fopenstat),"",fopenstat_capi,"string_from_pyobj failed in converting 13rd argument`fopenstat' of swift.swift_mvs_j_gr to C string");
    if (f2py_success) {
        STRINGPADN(fopenstat, slen(fopenstat), '\0', ' ');
    /* Processing variable lflg */
    lflg_Dims[0]=6;
    capi_lflg_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "swift.swift.swift_mvs_j_gr: failed to create array from the 6th argument `lflg`";
    capi_lflg_as_array = ndarray_from_pyobj(  NPY_BYTE,1,lflg_Dims,lflg_Rank,  capi_lflg_intent,lflg_capi,capi_errmess);
    if (capi_lflg_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = swift_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        lflg = (char *)(PyArray_DATA(capi_lflg_as_array));

    /* Processing variable energy_out_size */
        f2py_success = int_from_pyobj(&energy_out_size,energy_out_size_capi,"swift.swift_mvs_j_gr() 17th argument (energy_out_size) can't be converted to int");
    if (f2py_success) {
    /* Processing variable coordinates */
    coordinates_Dims[0]=3 + 3 * nbod,coordinates_Dims[1]=3;
    capi_coordinates_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "swift.swift.swift_mvs_j_gr: failed to create array from the 15th argument `coordinates`";
    capi_coordinates_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,coordinates_Dims,coordinates_Rank,  capi_coordinates_intent,coordinates_capi,capi_errmess);
    if (capi_coordinates_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = swift_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        coordinates = (double *)(PyArray_DATA(capi_coordinates_as_array));

    /* Processing variable energy_out */
    energy_out_Dims[0]=energy_out_size,energy_out_Dims[1]=5;
    capi_energy_out_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "swift.swift.swift_mvs_j_gr: failed to create array from the hidden `energy_out`";
    capi_energy_out_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,energy_out_Dims,energy_out_Rank,  capi_energy_out_intent,Py_None,capi_errmess);
    if (capi_energy_out_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = swift_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        energy_out = (double *)(PyArray_DATA(capi_energy_out_as_array));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
                (*f2py_func)(&t0,&tstop,&dt,&dtout,&dtdump,lflg,&rmin,&rmax,&rmaxu,&qmin,&lclose,outfile,fopenstat,&nbod,coordinates,&ll,&energy_out_size,energy_out,slen(outfile),slen(fopenstat));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("N",capi_energy_out_as_array);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    }  /* if (capi_energy_out_as_array == NULL) ... else of energy_out */
    /* End of cleaning variable energy_out */
    if((PyObject *)capi_coordinates_as_array!=coordinates_capi) {
        Py_XDECREF(capi_coordinates_as_array); }
    }  /* if (capi_coordinates_as_array == NULL) ... else of coordinates */
    /* End of cleaning variable coordinates */
    } /*if (f2py_success) of energy_out_size*/
    /* End of cleaning variable energy_out_size */
    if((PyObject *)capi_lflg_as_array!=lflg_capi) {
        Py_XDECREF(capi_lflg_as_array); }
    }  /* if (capi_lflg_as_array == NULL) ... else of lflg */
    /* End of cleaning variable lflg */
        STRINGFREE(fopenstat);
    }  /*if (f2py_success) of fopenstat*/
    /* End of cleaning variable fopenstat */
        STRINGFREE(outfile);
    }  /*if (f2py_success) of outfile*/
    /* End of cleaning variable outfile */
    } /*if (f2py_success) of lclose*/
    /* End of cleaning variable lclose */
    } /*if (f2py_success) of qmin*/
    /* End of cleaning variable qmin */
    } /*if (f2py_success) of rmaxu*/
    /* End of cleaning variable rmaxu */
    } /*if (f2py_success) of rmax*/
    /* End of cleaning variable rmax */
    } /*if (f2py_success) of rmin*/
    /* End of cleaning variable rmin */
    } /*if (f2py_success) of dtdump*/
    /* End of cleaning variable dtdump */
    } /*if (f2py_success) of dtout*/
    /* End of cleaning variable dtout */
    } /*if (f2py_success) of dt*/
    /* End of cleaning variable dt */
    } /*if (f2py_success) of tstop*/
    /* End of cleaning variable tstop */
    } /*if (f2py_success) of t0*/
    /* End of cleaning variable t0 */
    } /*if (f2py_success) of nbod*/
    /* End of cleaning variable nbod */
    } /*if (f2py_success) of ll*/
    /* End of cleaning variable ll */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/*************************** end of swift_mvs_j_gr ***************************/

/******************************* follow_symba2 *******************************/
static char doc_f2py_rout_swift_follow_symba2[] = "\
symba_out = follow_symba2(t0,tstop,dt,dtout,dtdump,lflg,rmin,rmax,rmaxu,qmin,lclose,outfile,fopenstat,nbod,coordinates,ifol,symba_out_size)\n\nWrapper for ``follow_symba2``.\
\n\nParameters\n----------\n"
"t0 : input float\n"
"tstop : input float\n"
"dt : input float\n"
"dtout : input float\n"
"dtdump : input float\n"
"lflg : input rank-1 array('b') with bounds (6)\n"
"rmin : input float\n"
"rmax : input float\n"
"rmaxu : input float\n"
"qmin : input float\n"
"lclose : input int\n"
"outfile : input string(len=80)\n"
"fopenstat : input string(len=80)\n"
"nbod : input int\n"
"coordinates : input rank-2 array('d') with bounds (3 + 3 * nbod,3)\n"
"ifol : input int\n"
"symba_out_size : input int\n"
"\nReturns\n-------\n"
"symba_out : rank-2 array('d') with bounds (symba_out_size,11)";
/* extern void F_FUNC_US(follow_symba2,FOLLOW_SYMBA2)(double*,double*,double*,double*,double*,char*,double*,double*,double*,double*,short*,string,string,int*,double*,int*,int*,double*,size_t,size_t); */
static PyObject *f2py_rout_swift_follow_symba2(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,double*,double*,double*,double*,char*,double*,double*,double*,double*,short*,string,string,int*,double*,int*,int*,double*,size_t,size_t)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    double t0 = 0;
    PyObject *t0_capi = Py_None;
    double tstop = 0;
    PyObject *tstop_capi = Py_None;
    double dt = 0;
    PyObject *dt_capi = Py_None;
    double dtout = 0;
    PyObject *dtout_capi = Py_None;
    double dtdump = 0;
    PyObject *dtdump_capi = Py_None;
    char *lflg = NULL;
    npy_intp lflg_Dims[1] = {-1};
    const int lflg_Rank = 1;
    PyArrayObject *capi_lflg_as_array = NULL;
    int capi_lflg_intent = 0;
    PyObject *lflg_capi = Py_None;
    double rmin = 0;
    PyObject *rmin_capi = Py_None;
    double rmax = 0;
    PyObject *rmax_capi = Py_None;
    double rmaxu = 0;
    PyObject *rmaxu_capi = Py_None;
    double qmin = 0;
    PyObject *qmin_capi = Py_None;
    short lclose = 0;
    PyObject *lclose_capi = Py_None;
    string outfile = NULL;
    int slen(outfile);
    PyObject *outfile_capi = Py_None;
    string fopenstat = NULL;
    int slen(fopenstat);
    PyObject *fopenstat_capi = Py_None;
    int nbod = 0;
    PyObject *nbod_capi = Py_None;
    double *coordinates = NULL;
    npy_intp coordinates_Dims[2] = {-1, -1};
    const int coordinates_Rank = 2;
    PyArrayObject *capi_coordinates_as_array = NULL;
    int capi_coordinates_intent = 0;
    PyObject *coordinates_capi = Py_None;
    int ifol = 0;
    PyObject *ifol_capi = Py_None;
    int symba_out_size = 0;
    PyObject *symba_out_size_capi = Py_None;
    double *symba_out = NULL;
    npy_intp symba_out_Dims[2] = {-1, -1};
    const int symba_out_Rank = 2;
    PyArrayObject *capi_symba_out_as_array = NULL;
    int capi_symba_out_intent = 0;
    static char *capi_kwlist[] = {"t0","tstop","dt","dtout","dtdump","lflg","rmin","rmax","rmaxu","qmin","lclose","outfile","fopenstat","nbod","coordinates","ifol","symba_out_size",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOOOOOOOOOOOOOOO|:swift.follow_symba2",\
        capi_kwlist,&t0_capi,&tstop_capi,&dt_capi,&dtout_capi,&dtdump_capi,&lflg_capi,&rmin_capi,&rmax_capi,&rmaxu_capi,&qmin_capi,&lclose_capi,&outfile_capi,&fopenstat_capi,&nbod_capi,&coordinates_capi,&ifol_capi,&symba_out_size_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable nbod */
        f2py_success = int_from_pyobj(&nbod,nbod_capi,"swift.follow_symba2() 14th argument (nbod) can't be converted to int");
    if (f2py_success) {
    /* Processing variable ifol */
        f2py_success = int_from_pyobj(&ifol,ifol_capi,"swift.follow_symba2() 16th argument (ifol) can't be converted to int");
    if (f2py_success) {
    /* Processing variable t0 */
        f2py_success = double_from_pyobj(&t0,t0_capi,"swift.follow_symba2() 1st argument (t0) can't be converted to double");
    if (f2py_success) {
    /* Processing variable tstop */
        f2py_success = double_from_pyobj(&tstop,tstop_capi,"swift.follow_symba2() 2nd argument (tstop) can't be converted to double");
    if (f2py_success) {
    /* Processing variable dt */
        f2py_success = double_from_pyobj(&dt,dt_capi,"swift.follow_symba2() 3rd argument (dt) can't be converted to double");
    if (f2py_success) {
    /* Processing variable dtout */
        f2py_success = double_from_pyobj(&dtout,dtout_capi,"swift.follow_symba2() 4th argument (dtout) can't be converted to double");
    if (f2py_success) {
    /* Processing variable dtdump */
        f2py_success = double_from_pyobj(&dtdump,dtdump_capi,"swift.follow_symba2() 5th argument (dtdump) can't be converted to double");
    if (f2py_success) {
    /* Processing variable rmin */
        f2py_success = double_from_pyobj(&rmin,rmin_capi,"swift.follow_symba2() 7th argument (rmin) can't be converted to double");
    if (f2py_success) {
    /* Processing variable rmax */
        f2py_success = double_from_pyobj(&rmax,rmax_capi,"swift.follow_symba2() 8th argument (rmax) can't be converted to double");
    if (f2py_success) {
    /* Processing variable rmaxu */
        f2py_success = double_from_pyobj(&rmaxu,rmaxu_capi,"swift.follow_symba2() 9th argument (rmaxu) can't be converted to double");
    if (f2py_success) {
    /* Processing variable qmin */
        f2py_success = double_from_pyobj(&qmin,qmin_capi,"swift.follow_symba2() 10th argument (qmin) can't be converted to double");
    if (f2py_success) {
    /* Processing variable lclose */
        lclose = (short)PyObject_IsTrue(lclose_capi);
        f2py_success = 1;
    if (f2py_success) {
    /* Processing variable outfile */
    slen(outfile) = 80;
    f2py_success = string_from_pyobj(&outfile,&slen(outfile),"",outfile_capi,"string_from_pyobj failed in converting 12nd argument`outfile' of swift.follow_symba2 to C string");
    if (f2py_success) {
        STRINGPADN(outfile, slen(outfile), '\0', ' ');
    /* Processing variable fopenstat */
    slen(fopenstat) = 80;
    f2py_success = string_from_pyobj(&fopenstat,&slen(fopenstat),"",fopenstat_capi,"string_from_pyobj failed in converting 13rd argument`fopenstat' of swift.follow_symba2 to C string");
    if (f2py_success) {
        STRINGPADN(fopenstat, slen(fopenstat), '\0', ' ');
    /* Processing variable lflg */
    lflg_Dims[0]=6;
    capi_lflg_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "swift.swift.follow_symba2: failed to create array from the 6th argument `lflg`";
    capi_lflg_as_array = ndarray_from_pyobj(  NPY_BYTE,1,lflg_Dims,lflg_Rank,  capi_lflg_intent,lflg_capi,capi_errmess);
    if (capi_lflg_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = swift_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        lflg = (char *)(PyArray_DATA(capi_lflg_as_array));

    /* Processing variable symba_out_size */
        f2py_success = int_from_pyobj(&symba_out_size,symba_out_size_capi,"swift.follow_symba2() 17th argument (symba_out_size) can't be converted to int");
    if (f2py_success) {
    /* Processing variable coordinates */
    coordinates_Dims[0]=3 + 3 * nbod,coordinates_Dims[1]=3;
    capi_coordinates_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "swift.swift.follow_symba2: failed to create array from the 15th argument `coordinates`";
    capi_coordinates_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,coordinates_Dims,coordinates_Rank,  capi_coordinates_intent,coordinates_capi,capi_errmess);
    if (capi_coordinates_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = swift_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        coordinates = (double *)(PyArray_DATA(capi_coordinates_as_array));

    /* Processing variable symba_out */
    symba_out_Dims[0]=symba_out_size,symba_out_Dims[1]=11;
    capi_symba_out_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "swift.swift.follow_symba2: failed to create array from the hidden `symba_out`";
    capi_symba_out_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,symba_out_Dims,symba_out_Rank,  capi_symba_out_intent,Py_None,capi_errmess);
    if (capi_symba_out_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = swift_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        symba_out = (double *)(PyArray_DATA(capi_symba_out_as_array));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
                (*f2py_func)(&t0,&tstop,&dt,&dtout,&dtdump,lflg,&rmin,&rmax,&rmaxu,&qmin,&lclose,outfile,fopenstat,&nbod,coordinates,&ifol,&symba_out_size,symba_out,slen(outfile),slen(fopenstat));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("N",capi_symba_out_as_array);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    }  /* if (capi_symba_out_as_array == NULL) ... else of symba_out */
    /* End of cleaning variable symba_out */
    if((PyObject *)capi_coordinates_as_array!=coordinates_capi) {
        Py_XDECREF(capi_coordinates_as_array); }
    }  /* if (capi_coordinates_as_array == NULL) ... else of coordinates */
    /* End of cleaning variable coordinates */
    } /*if (f2py_success) of symba_out_size*/
    /* End of cleaning variable symba_out_size */
    if((PyObject *)capi_lflg_as_array!=lflg_capi) {
        Py_XDECREF(capi_lflg_as_array); }
    }  /* if (capi_lflg_as_array == NULL) ... else of lflg */
    /* End of cleaning variable lflg */
        STRINGFREE(fopenstat);
    }  /*if (f2py_success) of fopenstat*/
    /* End of cleaning variable fopenstat */
        STRINGFREE(outfile);
    }  /*if (f2py_success) of outfile*/
    /* End of cleaning variable outfile */
    } /*if (f2py_success) of lclose*/
    /* End of cleaning variable lclose */
    } /*if (f2py_success) of qmin*/
    /* End of cleaning variable qmin */
    } /*if (f2py_success) of rmaxu*/
    /* End of cleaning variable rmaxu */
    } /*if (f2py_success) of rmax*/
    /* End of cleaning variable rmax */
    } /*if (f2py_success) of rmin*/
    /* End of cleaning variable rmin */
    } /*if (f2py_success) of dtdump*/
    /* End of cleaning variable dtdump */
    } /*if (f2py_success) of dtout*/
    /* End of cleaning variable dtout */
    } /*if (f2py_success) of dt*/
    /* End of cleaning variable dt */
    } /*if (f2py_success) of tstop*/
    /* End of cleaning variable tstop */
    } /*if (f2py_success) of t0*/
    /* End of cleaning variable t0 */
    } /*if (f2py_success) of ifol*/
    /* End of cleaning variable ifol */
    } /*if (f2py_success) of nbod*/
    /* End of cleaning variable nbod */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/**************************** end of follow_symba2 ****************************/
/*eof body*/

/******************* See f2py2e/f90mod_rules.py: buildhooks *******************/
/*need_f90modhooks*/

/************** See f2py2e/rules.py: module_rules['modulebody'] **************/

/******************* See f2py2e/common_rules.py: buildhooks *******************/

/*need_commonhooks*/

/**************************** See f2py2e/rules.py ****************************/

static FortranDataDef f2py_routine_defs[] = {
    {"geninit_j3_in_days",-1,{{-1}},0,0,(char *)  F_FUNC_US(geninit_j3_in_days,GENINIT_J3_IN_DAYS),  (f2py_init_func)f2py_rout_swift_geninit_j3_in_days,doc_f2py_rout_swift_geninit_j3_in_days},
    {"swift_symba5_j",-1,{{-1}},0,0,(char *)  F_FUNC_US(swift_symba5_j,SWIFT_SYMBA5_J),  (f2py_init_func)f2py_rout_swift_swift_symba5_j,doc_f2py_rout_swift_swift_symba5_j},
    {"swift_mvs_j",-1,{{-1}},0,0,(char *)  F_FUNC_US(swift_mvs_j,SWIFT_MVS_J),  (f2py_init_func)f2py_rout_swift_swift_mvs_j,doc_f2py_rout_swift_swift_mvs_j},
    {"swift_mvs_j_gr",-1,{{-1}},0,0,(char *)  F_FUNC_US(swift_mvs_j_gr,SWIFT_MVS_J_GR),  (f2py_init_func)f2py_rout_swift_swift_mvs_j_gr,doc_f2py_rout_swift_swift_mvs_j_gr},
    {"follow_symba2",-1,{{-1}},0,0,(char *)  F_FUNC_US(follow_symba2,FOLLOW_SYMBA2),  (f2py_init_func)f2py_rout_swift_follow_symba2,doc_f2py_rout_swift_follow_symba2},

/*eof routine_defs*/
    {NULL}
};

static PyMethodDef f2py_module_methods[] = {

    {NULL,NULL}
};

static struct PyModuleDef moduledef = {
    PyModuleDef_HEAD_INIT,
    "swift",
    NULL,
    -1,
    f2py_module_methods,
    NULL,
    NULL,
    NULL,
    NULL
};

PyMODINIT_FUNC PyInit_swift(void) {
    int i;
    PyObject *m,*d, *s, *tmp;
    m = swift_module = PyModule_Create(&moduledef);
    Py_SET_TYPE(&PyFortran_Type, &PyType_Type);
    import_array();
    if (PyErr_Occurred())
        {PyErr_SetString(PyExc_ImportError, "can't initialize module swift (failed to import numpy)"); return m;}
    d = PyModule_GetDict(m);
    s = PyUnicode_FromString("2.0.2");
    PyDict_SetItemString(d, "__version__", s);
    Py_DECREF(s);
    s = PyUnicode_FromString(
        "This module 'swift' is auto-generated with f2py (version:2.0.2).\nFunctions:\n"
"    planets_results,coordinates = geninit_j3_in_days(iuflg,mstar0,nbod,frho3,planets_params)\n"
"    energy_out = swift_symba5_j(t0,tstop,dt,dtout,dtdump,lflg,rmin,rmax,rmaxu,qmin,lclose,outfile,fopenstat,nbod,coordinates,mtiny,energy_out_size)\n"
"    energy_out = swift_mvs_j(t0,tstop,dt,dtout,dtdump,lflg,rmin,rmax,rmaxu,qmin,lclose,outfile,fopenstat,nbod,coordinates,energy_out_size)\n"
"    energy_out = swift_mvs_j_gr(t0,tstop,dt,dtout,dtdump,lflg,rmin,rmax,rmaxu,qmin,lclose,outfile,fopenstat,nbod,coordinates,ll,energy_out_size)\n"
"    symba_out = follow_symba2(t0,tstop,dt,dtout,dtdump,lflg,rmin,rmax,rmaxu,qmin,lclose,outfile,fopenstat,nbod,coordinates,ifol,symba_out_size)\n"
".");
    PyDict_SetItemString(d, "__doc__", s);
    Py_DECREF(s);
    s = PyUnicode_FromString("2.0.2");
    PyDict_SetItemString(d, "__f2py_numpy_version__", s);
    Py_DECREF(s);
    swift_error = PyErr_NewException ("swift.error", NULL, NULL);
    /*
     * Store the error object inside the dict, so that it could get deallocated.
     * (in practice, this is a module, so it likely will not and cannot.)
     */
    PyDict_SetItemString(d, "_swift_error", swift_error);
    Py_DECREF(swift_error);
    for(i=0;f2py_routine_defs[i].name!=NULL;i++) {
        tmp = PyFortranObject_NewAsAttr(&f2py_routine_defs[i]);
        PyDict_SetItemString(d, f2py_routine_defs[i].name, tmp);
        Py_DECREF(tmp);
    }





/*eof initf2pywraphooks*/
/*eof initf90modhooks*/

/*eof initcommonhooks*/


#ifdef F2PY_REPORT_ATEXIT
    if (! PyErr_Occurred())
        on_exit(f2py_report_on_exit,(void*)"swift");
#endif
    return m;
}
#ifdef __cplusplus
}
#endif
